Summary: Constant Database FILE
Name: cdb
Packager: Michael De La Rue <miked@ed.ac.uk>
Version: 0.55
#Releases below 10 are reserved for RPM 3 format
Release: 10
Copyright: Public Domain Code / Don't Modify Package / GPL
#maybe should be library too.
Group: Applications/Databases
Source0: ftp://etc../cdb-0.55.tar.gz
Patch0: cdb_open_match.patch
Patch1: cdb_multiget.patch
Patch2: cdb_TODO.patch
Patch3: cdb_main_is_int.patch
Patch4: cdb_doc_changes.patch
BuildRoot: /var/tmp/cdb-0.55

%description
A constant database file is very similar in use to a normal DBM file
(at least from the point of view of the tied hash interface in perl)
but is faster (much of the time.. I haven't tested this myself) and
more compact (much more compact in bad cases..  My database shrunk
from 20MB to 700k).  

This is done by sacrificing the ability to change the database
continuously.  Instead it must be rewritten from scratch.  Since,
however, this can be a very fast operation (provided you don't need to
keep referencing the data you are writing, or you use a normal DBM to
keep that in) this isn't a bad sacrifice in many cases.

%package lib
Summary: Libraries needed for CDB programs.
Group: Libraries
%description lib
A constant database file is very similar in use to a normal DBM file
(at least from the point of view of the tied hash interface in perl)
but is faster (much of the time.. I haven't tested this myself) and
more compact (much more compact in bad cases..  My database shrunk
from 20MB to 700k).  

This is done by sacrificing the ability to change the database
continuously.  Instead it must be rewritten from scratch.  Since,
however, this can be a very fast operation (provided you don't need to
keep referencing the data you are writing, or you use a normal DBM to
keep that in) this isn't a bad sacrifice in many cases.

This library provides a set of functions for searching through and
extracting information from CDB files.

%post lib
ldconfig
%postun lib
ldconfig
%package util
Summary: Utility programs for manipulating CDB files
Group: Applications/Databases
%description util
A constant database file is very similar in use to a normal DBM file
(at least from the point of view of the tied hash interface in perl)
but is faster (much of the time.. I haven't tested this myself) and
more compact (much more compact in bad cases..  My database shrunk
from 20MB to 700k).  

This is done by sacrificing the ability to change the database
continuously.  Instead it must be rewritten from scratch.  Since,
however, this can be a very fast operation (provided you don't need to
keep referencing the data you are writing, or you use a normal DBM to
keep that in) this isn't a bad sacrifice in many cases.

There are two groups of utilities in this package.  The first set
allow the recovery of information from CDB files.

The second set cdbdump and cdbmake allow conversion of CDB files to
and from a readable ASCII format.

%package devel
Summary: Include files etc. for CDB libraries.
Group: Development/Libraries
%description devel
A constant database file is very similar in use to a normal DBM file
(at least from the point of view of the tied hash interface in perl)
but is faster (much of the time.. I haven't tested this myself) and
more compact (much more compact in bad cases..  My database shrunk
from 20MB to 700k).  

This is done by sacrificing the ability to change the database
continuously.  Instead it must be rewritten from scratch.  Since,
however, this can be a very fast operation (provided you don't need to
keep referencing the data you are writing, or you use a normal DBM to
keep that in) this isn't a bad sacrifice in many cases.

The include files in this RPM make it possible to link your own
programs to CDB.

%prep
%setup -n cdb-0.55_1
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%build
#the default compile system is kind of minimalist and a bit strange.
#It might be worth hacking around with it more cleverly.

#create the needed header files

make uint32.h

GCCOPT='-O2'

LIB_OBJECTS="cdb_hash cdb_seek cdb_unpack cdbmake_add cdbmake_hash cdbmake_pack"
for i in $LIB_OBJECTS
do
	gcc $GCCOPT -c -fPIC $i.c -o $i.o
done
#We include the cdbmake functions.  I think this is useful.  It makes
#it possible to make self contained C applications which use CDB.
gcc -shared -Wl,-soname,libcdb.so.0 -o libcdb.so.0.55 *.o

#multiget was written by M. De La Rue as an addition to the package.
PROGRAM_OBJECTS="cdbdump cdbget cdbmake cdbmultiget cdbstats cdbtest"
for i in $PROGRAM_OBJECTS
do
	gcc $GCCOPT -c $i.c -o $i.o 
	gcc -o $i $i.o libcdb.so.0.55
done

for i in cdb.h cdbmake.h
do
	mv $i $i.orig
	sed -e '/include/r uint32.h' -e '/include/d' $i.orig > $i
done

%install
rm -rf $RPM_BUILD_ROOT

install -o root -g root -m 755 -d $RPM_BUILD_ROOT/%_libdir
install -o root -g root -m 755 libcdb.so.0.55 $RPM_BUILD_ROOT/%_libdir
ln -fs libcdb.so.0.55 $RPM_BUILD_ROOT/%_libdir/libcdb.so
install -o root -g root -m 755 -d $RPM_BUILD_ROOT/%_mandir/man3
install -o root -g root -m 755 cdb.3 $RPM_BUILD_ROOT/%_mandir/man3

install -o root -g root -m 755 -d $RPM_BUILD_ROOT/%_bindir
install -o root -g root -m 755 cdbdump cdbget cdbmake cdbmultiget cdbstats cdbtest $RPM_BUILD_ROOT/%_bindir

install -o root -g root -m 755 -d $RPM_BUILD_ROOT/%_mandir/man1
install -o root -g root -m 755 cdbdump.1 cdbget.1 cdbmultiget.1 cdbmake.1 cdbstats.1 cdbtest.1 $RPM_BUILD_ROOT/%_mandir/man1

install -o root -g root -m 755 -d $RPM_BUILD_ROOT/%_includedir
install -o root -g root -m 755 cdb.h cdbmake.h $RPM_BUILD_ROOT/%_includedir

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files lib
%doc BLURB CDB README TODO PACKAGE-CHANGES
%_libdir/libcdb.so.0.55
%_libdir/libcdb.so
%_mandir/man3/cdb.3*

%files util
%_bindir/cdbdump
%_bindir/cdbget
%_bindir/cdbmake
%_bindir/cdbmultiget
%_bindir/cdbstats
%_bindir/cdbtest
%_mandir/man1/cdbdump.1*
%_mandir/man1/cdbget.1*
%_mandir/man1/cdbmultiget.1*
%_mandir/man1/cdbmake.1*
%_mandir/man1/cdbstats.1*
%_mandir/man1/cdbtest.1*

%files devel
%_includedir/cdb.h
%_includedir/cdbmake.h
